<template>
  <div class="md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100 base-datatable">
    <md-card class="md-card-plain">
      <md-card-content>
        <md-table>
          <md-table-toolbar>
            <slot name="table-toolbar"></slot>
          </md-table-toolbar>

          <md-table-row @click="onSort">
            <slot/>
          </md-table-row>
          <slot name="header-body"></slot>
          <slot v-for="(row, index) in rows" name="body" :item="row" :index="index"/>

          <md-table-row v-if="!fetching">
            <td colspan="100%">
              <div class="md-content md-table-content"
                   v-if="rows.length === 0">
                <div class=" md-empty-state md-table-empty-state md-theme-default">
                  <div class="md-empty-state-container">
                    <strong class="md-empty-state-label">No data found</strong>
                  </div>
                </div>
              </div>
            </td>
          </md-table-row>

        </md-table>
      </md-card-content>
      <md-card-actions>
        <uib-pagination
          v-if="lastPage > 1"
          v-model="pagination"
          :items-per-page="perPage"
          :max-size="chunk"
          :total-items="totalRecord"
          class="product__paginate"
          :boundary-links="true"
          previous-text=''
          next-text=''
          @change="fetch()">
        </uib-pagination>
      </md-card-actions>
    </md-card>
  </div>
</template>

<script>
  export default {
    props: {
      getData: {
        type: Function,
      },
      limit: {
        type: Number,
        default: 20
      },
      chunk: {
        type: Number,
        default: 5
      },
    },
    data() {
      return {
        totalRecord: 0,
        lastPage: 0,
        page: 1,
        perPage: 10,
        column: 0,
        fetching: false,
        rows: [],
        params: {},

        pagination: {},
      };
    },
    methods: {
      onPageChange(page) {
        this.page = page;
        this.fetch();
      },

      fetch() {
        const meta = {
          page: this.pagination.currentPage,
          limit: this.limit,
        };

        this.fetching = true;
        this.getData(Object.assign(meta, this.params)).then((res) => {

          this.page = parseInt(res.meta.current_page);
          this.totalRecord = parseInt(res.meta.total);
          this.lastPage = parseInt(res.meta.last_page);
          this.perPage = parseInt(res.meta.per_page);
          this.rows = [...res.data] || [];

          this.$emit('DataTable:finish');
        }).finally(() => {
          this.fetching = false;
        });
      },

      refresh() {
        this.pagination.currentPage = this.page = 1;
        this.params = {};
        this.fetch();
      },

      onSort(event) {
        const target = this.getTarget(event.target);
        const orderBy = target.dataset.sortField;
        if (!orderBy) {
          return
        }
        this.sortedBy = this.getSortOrder(target);
        this.orderBy = this.sortedBy ? orderBy : '';
        Object.assign(this.params, {sortField: this.orderBy, sortDirection: this.sortedBy});
        this.setSortOrders(target, this.sortedBy);
        this.fetch();
      },

      getTarget(target) {
        let node = target;
        while (node.parentNode.nodeName !== 'TR') {
          node = node.parentNode;
        }
        return node;
      },

      getSortOrder(target) {
        let sortOrder = target.dataset.sortOrder || '';
        switch (sortOrder) {
          case 'asc':
            sortOrder = '';
            break;
          case 'desc':
            sortOrder = 'asc';
            break;
          default:
            sortOrder = 'desc';
        }
        return sortOrder;
      },

      setSortOrders (target, sortOrder) {
        let iterator = target.parentNode.firstChild;
        while (iterator) {
          if (iterator.dataset) {
            iterator.dataset.sortOrder = '';
          }
          iterator = iterator.nextElementSibling;
        }
        target.dataset.sortOrder = sortOrder;
      }

    },
    created() {
      this.fetch();
    },
  }
</script>

<style lang="scss">
  .md-table-cell-container {
     padding: 0 0 0 17px !important;
  }

  .md-table-head-label {
    width: 100%;
  }


  .product__paginate {
    li {
      display: inline-block;
    }
  }
  .pagination-prev,
  .pagination-next {
    position: relative;

    a {
      position: relative;
      z-index: 1;
    }
  }
  .pagination-prev:before,
  .pagination-next:before {
    content: '';
    display: block;
    width: 10px;
    height: 10px;
    background-image: url('/images/prev.png');
    background-size: cover;
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }
  .pagination-next:before {
    background-image: url('/images/next.png');
  }

  .base-datatable {
    /*th[data-sort-field]::after {*/
      /*font-family: 'Glyphicons Halflings', sans-serif;*/
      /*margin-left: 1.5em;*/
      /*vertical-align: middle;*/
      /*font-size: 9px;*/
    /*}*/
    th:hover {
      cursor: default;
    }

    th[data-sort-order='desc']::after {
      content: '';
      display: block;
      width: 20px;
      height: 20px;
      background-size: cover;
      position: absolute;
      left: 95%;
      top: 5px;
      background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAGAAAABgCAQAAABIkb+zAAABZUlEQVR4Ae3PgYZCYRDF8QEkEbEABMAF95vXW9TCAgJ6loVAEAgX9nGKCzhuDl+TMZwDGIz/zzRN0zRN0zRN0z6zdmiH0vn+8AcQquUDoVo+EKrlA6FyPhIK5iOhYD4SCuYjoWA+EgrmI6FgPhIK5iOhYD4SCuZzQmp+++MXTsjLv+xXeNuv2iWL0JFvhlezPEJH/hLAOCE/369z/jJgJviVExLzfW32EjDP15yQms8AnJCczwGckJ6/DADCbZmQk3/DfAYwGzbdhPj8YWM4AiCE/HwKIITUfAJAwr2DEJZ/x3wOwPm2gxCV71uzfgAnJOQTQAKB5fcDkDB9iOA/JL8XABt2S4TxaO+vneDthPn9AEL4tYAhYRp2ZiEAQmgni5ufMT8MgIT/yHwkYH4EADZ+zYSzxW88Qn4cAAjjt+WPA7IngAACCCCAAAIIIIAAAggggAACCJAwAQTQNE3TNE3TNE17AupEDH8qEgttAAAAAElFTkSuQmCC);
    }

    th[data-sort-order='asc']::after {
      content: '';
      display: block;
      width: 20px;
      height: 20px;
      background-size: cover;
      position: absolute;
      left: 95%;
      top: 5px;
      background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAGAAAABgCAQAAABIkb+zAAABUklEQVR4Ae3PgWbDYBRH8VuYiBBC33amBgMUGGCvsUFBoaAI7HG64MO21HZt9xSc/wXiC+cXzjnnnHPOOVe9zeXrCRAgQIAAAQIECBAgQIAAAQIECBAg4I+7j+1NAFM8xCbKt18i3mOLA6aYl9cvQP5yjQACxpjb+2cgvxEmDDDG+dMf+yja07eUOSYE0PKrCS0/TUgAEvnt4jH+vd3mcpUwVgJW+e1iF0ERzjGWAQYqP0EoAAxxQvPzhDyAz88ThhwAyi8gnGLIAKB8gJAH9EB+ASEL6ONYmF9A6BMALr+AcIw+AWDyAcIKwOQDhF8BHZpfQOh+BHRxQPMLCIforgHQfICwAqD5AOFu9Y3MBwivqy9vZD5AWB+fzxP4fJ7A5/MEPp8m8Pkogc9HCXw+SuDzUQKfjxL4fJTA56MEPh8l8Pkogc9HCVS+c84555xzzn0AkCYrTZYSqawAAAAASUVORK5CYII=);
    }
  }
</style>
